#include <QtQml/QQmlContext>
#include <QtQml/QQmlApplicationEngine>
#include <QtRemoteObjects/QAbstractItemModelReplica>
#include <QtRemoteObjects/QRemoteObjectNode>
#include <QtWidgets/QApplication>
#include <QtWidgets/QListView>



int main(int argc, char* argv[]) {
	QApplication app(argc, argv);

	QRemoteObjectNode node(QStringLiteral("tcp://127.0.0.1:55555"));
	QAbstractItemModelReplica* model = node.acquireModel("MyModel");

	// Q_ASSERT(last < rowCount(parent)) failure
	// QAbstractItemModel::beginRemoveRows called on empty model
	// from QAbstractItemModelReplicaImplementation::onRowsRemoved
	QQmlApplicationEngine engine;
	engine.rootContext()->setContextProperty("remoteModel", model);
	engine.load(QStringLiteral("qrc:/main.qml"));
	return engine.rootObjects().size() ? app.exec() : EXIT_FAILURE;
	
	// No Q_ASSERT failure
//	QListView view;
//	view.setModel(model);
//	view.show();
//	return app.exec();
};

